package cds.tuto;

import java.io.*;
import java.util.Enumeration;

import cds.savot.common.*;
import cds.savot.model.*;
import cds.savot.pull.*;

/** Cette classe affiche le contenu d'un fichier VOTable  l'cran
 *
 * @author Thomas Boch [CDS]
 */
public class PrintVOTable {

	public PrintVOTable() {}
	
	public void print(InputStream in) {
		// Le fichier VOTable est entirement charg en mmoire
		SavotPullParser sb = new SavotPullParser(in, SavotPullEngine.FULL, null);
 
		
		// on rcupre l'objet VOTable
		SavotVOTable sv = sb.getVOTable();
      
		

			// pour chaque RESOURCE
			for (int l = 0; l < sb.getResourceCount(); l++) {
 				System.out.println("Lecture de la RESOURCE n "+l);
				SavotResource currentResource = (SavotResource)(sv.getResources().getItemAt(l));
				
				// pour chaque TABLE de la RESOURCE courante
				for (int m = 0; m < currentResource.getTableCount(); m++) {
					SavotTable currentTable = (SavotTable)currentResource.getTables().getItemAt(m);
					// On rcupre l'ensemble des champs
					FieldSet fset = currentTable.getFields();
					Enumeration enumFields = fset.getItems().elements();
					while( enumFields.hasMoreElements() ) {
						SavotField field = (SavotField)enumFields.nextElement();
						System.out.println("FIELD "+field.getName()+"\t ID= "+field.getId()+"\t ucd="+field.getUcd()+"\t unit="+field.getUnit());
					}
					
					// Analyse des groupes
					// A COMPLETER : dcommenter les lignes ci-dessous
					/*
					System.out.println("\n**** Analayse des GROUP ****");
					GroupSet gset = currentTable.getGroups();
					Enumeration enumGroup = gset.getItems().elements();
					while( enumGroup.hasMoreElements() ) {
						SavotGroup group = (SavotGroup)enumGroup.nextElement();
						String s = "";
						FieldRefSet fieldRefs = group.getFieldsRef();
						Enumeration enumRef = fieldRefs.getItems().elements();
						while( enumRef.hasMoreElements() ) s += ((SavotFieldRef)enumRef.nextElement()).getRef()+", ";
						
						System.out.println("\t Le GROUP nomm "+group.getName()+" regroupe les FIELD ayant pour ID : "+s);
					}
					System.out.println("*****************************\n");
					*/
					
					// on rcupre toutes les lignes de la table courante
					TRSet tr = currentResource.getTRSet(m);

					System.out.println("Nombre d'lments dans TRset (= nombre de <TR></TR>) : " + tr.getItemCount());

					// pour chaque ligne
					for (int i = 0; i < tr.getItemCount(); i++) {

						// on rcupre l'ensemble des cellules
						TDSet theTDs = tr.getTDSet(i);
						//System.out.println("Nombre d'lments dans TDSet pour l'index " + (i+1) + " tr (= nombre <TD></TD>) : " + theTDs.getItemCount());

						// pour chaque cellule de la ligne
						for (int j = 0; j < theTDs.getItemCount(); j++) {
							System.out.print(theTDs.getContent(j)+"\t");
						}
						System.out.println("\n");
					}
				}
			}
			
		
	}
	
	/** Affiche un fichier VOTable
	 * 1er arg. : fichier VOTable  afficher
	 * 2e arg. (facultatif) : nom fichier o rediriger la sortie
	 * si le 2e argument est manquant, on crit le VOTable sur stdout
	 */
	public static void main(String[] args) {
		if( args.length==0 ) {
			System.out.println("Error : please enter the name of the VOTable file");
			return;
		}

		try {
			
			InputStream in = new FileInputStream(args[0]);

			new PrintVOTable().print(in);
		} catch( FileNotFoundException e ) {
			System.out.println("File not found !!");
			e.printStackTrace();
		}

	}
	

}
