// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AdvancedPlotFormatter.java

package voplot.ptolemy.plot;

import com.jvt.utils.JVTUtil;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Vector;
import javax.swing.*;
import javax.swing.border.TitledBorder;

// Referenced classes of package ptolemy.plot:
//            PlotBox, Plot

class AdvancedPlotFormatter extends JPanel
{

    public AdvancedPlotFormatter(Plot plot)
    {
        _plot = null;
        _centerPanel = new JPanel();
        _gridLayout1 = new GridLayout();
        _datasetLabel = new JLabel();
        _markerStyleLabel = new JLabel();
        _colorLabel = new JLabel();
        _datasetsComboBox = new JComboBox();
        _markerStylesComboBox = new JComboBox();
        _colorChooserButton = new JButton();
        _borderLayout1 = new BorderLayout();
        currentDatasetIndex = 0;
        _plot = plot;
        try
        {
            jbInit();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
    }

    private void jbInit()
        throws Exception
    {
        TitledBorder titledborder = new TitledBorder(BorderFactory.createEtchedBorder(), " Select marker style and color ");
        _legendColors = (Vector)_plot.getLegendColors().clone();
        _legendStyles = (Vector)_plot.getLegendDatasets().clone();
        setLayout(_borderLayout1);
        _centerPanel.setLayout(_gridLayout1);
        _gridLayout1.setColumns(2);
        _gridLayout1.setHgap(35);
        _gridLayout1.setRows(3);
        _gridLayout1.setVgap(20);
        _datasetLabel.setText("      Dataset :");
        _markerStyleLabel.setText("      Marker Style :");
        _colorLabel.setText("      Color :");
        _datasetsComboBox.setToolTipText("Select Dataset");
        JVTUtil.usePlainFont(_datasetsComboBox);
        _datasetsComboBox.setBackground(Color.white);
        _datasetsComboBox.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                _datasetsComboBox_actionPerformed(actionevent);
            }

        });
        _markerStylesComboBox.setToolTipText("Select Marker style");
        _markerStylesComboBox.setBackground(Color.white);
        _markerStylesComboBox.setMaximumRowCount(10);
        JVTUtil.usePlainFont(_markerStylesComboBox);
        _colorChooserButton.setToolTipText("Select Color");
        _colorChooserButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                _colorChooserButton_actionPerformed(actionevent);
            }

        });
        initializeDatasetsComboBox();
        initializeMarkerStylesComboBox();
        setMaximumSize(new Dimension(292, 143));
        setPreferredSize(new Dimension(292, 143));
        add(_centerPanel, "Center");
        setBorder(titledborder);
        _centerPanel.add(_datasetLabel);
        _centerPanel.add(_datasetsComboBox);
        _centerPanel.add(_markerStyleLabel);
        _centerPanel.add(_markerStylesComboBox);
        _centerPanel.add(_colorLabel);
        _centerPanel.add(_colorChooserButton);
        _markerStylesComboBox.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                _markerStylesComboBox_actionPerformed(actionevent);
            }

        });
        refresh();
    }

    public void initializeDatasetsComboBox()
    {
        Enumeration enumeration = _plot.getLegendStrings().elements();
        boolean flag = true;
        for(int i = 0; enumeration.hasMoreElements(); i++)
        {
            String s = (String)enumeration.nextElement();
            _datasetsComboBox.insertItemAt(s, i);
            if(flag)
            {
                _datasetsComboBox.setSelectedItem(s);
                flag = false;
            }
        }

    }

    public void initializeMarkerStylesComboBox()
    {
        if(_plot.getMarksStyle().equals("various"))
        {
            try
            {
                int i = 0;
                _markerStylesComboBox.removeAllItems();
                for(; i < _markerStyles.length; i++)
                {
                    String s1 = _markerStyles[i];
                    _markerStylesComboBox.insertItemAt(s1, i);
                }

                int j = ((Integer)_plot.getLegendStyles().elementAt(currentDatasetIndex)).intValue();
                _markerStylesComboBox.setSelectedItem(_markerStyles[j]);
            }
            catch(Exception exception)
            {
                System.out.println("Error while initializing marker and style " + exception.toString());
            }
        } else
        {
            _markerStylesComboBox.removeAllItems();
            String s = _plot.getMarksStyle();
            _markerStylesComboBox.insertItemAt(s, 0);
            _markerStylesComboBox.setSelectedItem(s);
        }
    }

    public void refresh()
    {
        currentDatasetIndex = _datasetsComboBox.getSelectedIndex();
        if(_plot.getMarksStyle().equals("various"))
            try
            {
                int i = ((Integer)_plot.getLegendStyles().elementAt(currentDatasetIndex)).intValue();
                _markerStylesComboBox.setSelectedItem(_markerStyles[i]);
            }
            catch(Exception exception)
            {
                System.out.println("Error while changing plot properties " + exception.toString());
            }
        if(_plot.getColor())
        {
            Color color = (Color)_plot.getLegendColors().elementAt(currentDatasetIndex);
            _colorChooserButton.setBackground(color);
        } else
        {
            Color color1 = Color.black;
            _colorChooserButton.setBackground(color1);
        }
    }

    void _datasetsComboBox_actionPerformed(ActionEvent actionevent)
    {
        refresh();
    }

    void _markerStylesComboBox_actionPerformed(ActionEvent actionevent)
    {
        int i = _markerStylesComboBox.getSelectedIndex();
        if(i != -1)
        {
            _plot.setMarkerStyle(currentDatasetIndex, i);
            _plot.repaint();
        }
    }

    void _colorChooserButton_actionPerformed(ActionEvent actionevent)
    {
        if(_plot.getColor())
        {
            JColorChooser jcolorchooser = new JColorChooser(_colorChooserButton.getBackground());
            Color color = JColorChooser.showDialog(this, "Select dataset color", _colorChooserButton.getBackground());
            if(color != null)
            {
                _colorChooserButton.setBackground(color);
                _plot.setColor(currentDatasetIndex, color);
                _plot.repaint();
            }
        } else
        {
            JOptionPane.showMessageDialog(this, "'Use Color' not Enabled !");
        }
    }

    void _cancelButton_actionPerformed(ActionEvent actionevent)
    {
        cancel();
    }

    public void cancel()
    {
        _plot.setLegendColors(_legendColors);
        for(int i = 0; i < _legendColors.size(); i++)
            _plot.setColor(i, (Color)_legendColors.elementAt(i));

        _plot.setLegendStyles(_legendStyles);
        for(int j = 0; j < _legendStyles.size(); j++)
            _plot.setMarkerStyle(j, ((Integer)_legendStyles.elementAt(j)).intValue());

        _plot.repaint();
    }

    public String toString()
    {
        return "AdvancedPlotFormatter";
    }

    private Plot _plot;
    private JPanel _centerPanel;
    private GridLayout _gridLayout1;
    private JLabel _datasetLabel;
    private JLabel _markerStyleLabel;
    private JLabel _colorLabel;
    private JComboBox _datasetsComboBox;
    private JComboBox _markerStylesComboBox;
    private JButton _colorChooserButton;
    private BorderLayout _borderLayout1;
    private static final String _markerStyles[] = {
        "filled circle", "cross", "square", "filled triangle", "diamond", "circle", "plus sign", "filled square", "triangle", "filled diamond"
    };
    private Vector _legendColors;
    private Vector _legendStyles;
    private int currentDatasetIndex;

}
