// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ColumnExprParser.java

package voplot.ptolemy.plot;

import com.jvt.exprparser.Expression_Parser;
import com.jvt.exprparser.SimpleNode;
import com.jvt.votable.*;
import java.io.ByteArrayInputStream;
import java.io.PrintStream;
import java.util.ArrayList;

public class ColumnExprParser
{
    class ColNumExpr
    {

        public void setExpr(String s)
        {
            _expr = s;
        }

        public void setColNum(int i)
        {
            _colNum = i;
        }

        public String getExpr()
        {
            return _expr;
        }

        public int getColNum()
        {
            return _colNum;
        }

        private String _expr;
        private int _colNum;

        public ColNumExpr()
        {
            _expr = null;
            _colNum = 0;
        }

        public ColNumExpr(int i, String s)
        {
            _expr = s;
            _colNum = i;
        }
    }


    public ColumnExprParser(PlotData plotdata)
    {
        _plotdata = null;
        _suffix = new StringBuffer();
        _colNumExpr = new ArrayList();
        _errorCode = 0;
        _colNumStr = "";
        _plotdata = plotdata;
    }

    private boolean parseExpression(String s)
    {
        int i = 0;
        boolean flag = false;
        StringBuffer stringbuffer = new StringBuffer();
        for(int k = 0; k < s.length(); k++)
            if(s.charAt(k) == '$')
            {
                int l = 0;
                if(k + 1 >= s.length() || !Character.isDigit(s.charAt(k + 1)))
                {
                    _errorCode = 4;
                    _colNumStr = "" + s.charAt(k + 1);
                    return false;
                }
                int j = k;
                char ac[] = new char[3];
                for(; k + 1 < s.length() && Character.isDigit(s.charAt(k + 1)) && l < 3; k++)
                {
                    ac[l] = s.charAt(k + 1);
                    l++;
                }

                int i1 = 0;
                String s2 = new String(ac, 0, l);
                try
                {
                    i1 = Integer.parseInt(s2);
                    if(--i1 < 0 || i1 >= _plotdata.getNumOfPlotColumns())
                    {
                        _errorCode = 4;
                        _colNumStr = "" + i1;
                        return false;
                    }
                }
                catch(NumberFormatException numberformatexception)
                {
                    System.err.println(numberformatexception.getMessage());
                    _errorCode = 4;
                    _colNumStr = s2;
                    return false;
                }
                String s3 = s.substring(i, j);
                ColNumExpr colnumexpr = new ColNumExpr(i1, s3);
                _colNumExpr.add(colnumexpr);
                if(k < s.length())
                    j = i = k + 1;
            }

        String s1 = "";
        if(i >= 0 && i <= s.length())
            s1 = s.substring(i);
        _suffix.append(s1);
        return true;
    }

    private String substituteData(int i)
    {
        StringBuffer stringbuffer = new StringBuffer();
        boolean flag = false;
        Object obj = null;
        for(int j = 0; j < _colNumExpr.size(); j++)
        {
            ColNumExpr colnumexpr = (ColNumExpr)_colNumExpr.get(j);
            stringbuffer.append(colnumexpr.getExpr());
            PlotColumn plotcolumn = _plotdata.getPlotColumn(colnumexpr.getColNum());
            Double double1 = plotcolumn.getData(i);
            if(null == double1)
                return null;
            stringbuffer.append(double1);
        }

        stringbuffer.append(_suffix);
        String s = stringbuffer.toString();
        return s;
    }

    private boolean evaluateExpression(PlotColumn plotcolumn)
    {
        int i = _plotdata.getNumOfRows();
        boolean flag = false;
        for(int j = 0; j < i; j++)
        {
            String s = substituteData(j);
            if(null == s)
                plotcolumn.addData(null);
            else
                try
                {
                    ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(s.getBytes());
                    Expression_Parser expression_parser = new Expression_Parser(bytearrayinputstream);
                    SimpleNode simplenode = expression_parser.parseExpression();
                    Object obj = simplenode.eval();
                    String s1 = obj.toString();
                    Double double1 = new Double(s1);
                    plotcolumn.addData(double1);
                    flag = true;
                }
                catch(Exception exception)
                {
                    System.out.println("Exception while evaluation of " + s);
                    System.err.println(exception.getMessage());
                    if(!flag)
                    {
                        _errorCode = 5;
                        return false;
                    }
                    plotcolumn.addData(null);
                }
                catch(Error error)
                {
                    System.err.println(error.getMessage());
                    if(!flag)
                    {
                        _errorCode = 5;
                        return false;
                    }
                    plotcolumn.addData(null);
                }
        }

        return true;
    }

    private boolean evaluateExpression(PlotFilter plotfilter)
    {
        Object obj = null;
        int i = _plotdata.getNumOfRows();
        boolean flag = false;
        for(int j = 0; j < i; j++)
        {
            String s = substituteData(j);
            if(null == s)
                plotfilter.addData(new Boolean(false));
            else
                try
                {
                    ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(s.getBytes());
                    Expression_Parser expression_parser = new Expression_Parser(bytearrayinputstream);
                    SimpleNode simplenode = expression_parser.parseExpression();
                    Boolean boolean1 = (Boolean)simplenode.eval();
                    plotfilter.addData(boolean1);
                    flag = true;
                }
                catch(Exception exception)
                {
                    System.out.println("Exception while evaluation of " + s);
                    System.out.println(exception.getMessage());
                    if(!flag)
                    {
                        _errorCode = 5;
                        return false;
                    }
                    plotfilter.addData(new Boolean(false));
                }
                catch(Error error)
                {
                    System.out.println(error.getMessage());
                    if(!flag)
                    {
                        _errorCode = 5;
                        return false;
                    }
                    plotfilter.addData(new Boolean(false));
                }
        }

        return true;
    }

    public boolean parseAndEvaluate(String s, PlotColumn plotcolumn)
    {
        if(!parseExpression(s))
            return false;
        else
            return evaluateExpression(plotcolumn);
    }

    public boolean parseAndEvaluate(String s, PlotFilter plotfilter)
    {
        if(!parseExpression(s))
            return false;
        else
            return evaluateExpression(plotfilter);
    }

    public int getErrorCode()
    {
        return _errorCode;
    }

    public String getColumnNumber()
    {
        return _colNumStr;
    }

    private PlotData _plotdata;
    private StringBuffer _suffix;
    private ArrayList _colNumExpr;
    private int _errorCode;
    private String _colNumStr;
    private static final int MAX_COL_DIGITS = 3;
    private static final char COL_PREFIX_CHAR = 36;
}
