// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Histogram.java

package voplot.ptolemy.plot;

import java.awt.*;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.*;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            PlotBox

public class Histogram extends PlotBox
{

    public Histogram()
    {
        _currentdataset = -1;
        _points = new Vector();
        _histogram = new Vector();
        _barwidth = 0.5D;
        _baroffset = 0.14999999999999999D;
        _binWidth = 1.0D;
        _binOffset = 0.5D;
        _filename = null;
        _showing = false;
        _yIncremented = false;
    }

    public void addLegend(int i, String s)
    {
        _checkDatasetIndex(i);
        super.addLegend(i, s);
    }

    public void setYIncremented(boolean flag)
    {
        _yIncremented = flag;
    }

    public boolean isYIncremented()
    {
        return _yIncremented;
    }

    public synchronized void addPoint(final int dataset, final double value)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _addPoint(dataset, value);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void addPoint(int i, double d, boolean flag)
    {
        if(flag)
            _addPoint(i, d);
        else
            addPoint(i, d);
    }

    public synchronized void addPoint(int i, double d, double d1, boolean flag)
    {
        addPoint(i, d1, false);
    }

    public synchronized void addPoint(int i, double d, double d1, boolean flag, boolean flag1)
    {
        addPoint(i, d1, flag1);
    }

    public synchronized void clear(final boolean format)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _clear(format);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void clear(boolean flag, boolean flag1)
    {
        if(flag1)
            _clear(flag);
        else
            clear(flag);
    }

    public synchronized void fillPlot()
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _fillPlot();
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void samplePlot()
    {
        clear(true);
        setTitle("Sample histogram");
        setXLabel("values");
        setYLabel("count");
        Random random = new Random();
        for(int i = 0; i <= 1000; i++)
        {
            addPoint(0, 5D * Math.cos((3.1415926535897931D * (double)i) / 500D));
            addPoint(1, 10D * random.nextDouble() - 5D);
            addPoint(2, 2D * random.nextGaussian());
        }

        repaint();
    }

    public synchronized void setBars(double d, double d1)
    {
        _barwidth = d;
        _baroffset = d1;
    }

    public synchronized void setBinOffset(double d)
    {
        _binOffset = d;
    }

    public void setBinWidth(double d)
    {
        if(d >= 0.0D)
            _binWidth = d;
        else
            System.out.println("Error changing BinWidth : BinWidth has to be greater than 0.0");
    }

    public double getBinWidth()
    {
        return _binWidth;
    }

    public synchronized void writeData(PrintWriter printwriter)
    {
        super.writeData(printwriter);
        for(int i = 0; i < _points.size(); i++)
        {
            String s = getLegend(i);
            if(s != null)
                printwriter.println("<dataset name=\"" + s + "\">");
            else
                printwriter.println("<dataset>");
            Vector vector = (Vector)_points.elementAt(i);
            for(int j = 0; j < vector.size(); j++)
            {
                Double double1 = (Double)vector.elementAt(j);
                printwriter.println("<p y=\"" + double1.doubleValue() + "\"/>");
            }

            printwriter.println("</dataset>");
        }

    }

    public synchronized void writeFormat(PrintWriter printwriter)
    {
        super.writeFormat(printwriter);
        printwriter.println("<barGraph width=\"" + _barwidth + "\" offset=\"" + _baroffset + "\"/>");
        printwriter.println("<bin width=\"" + _binWidth + "\" offset=\"" + _binOffset + "\"/>");
    }

    protected void _checkDatasetIndex(int i)
    {
        if(i < 0)
            throw new IllegalArgumentException("Plot._checkDatasetIndex: Cannot give a negative number for the data set index.");
        for(; i >= _points.size(); _histogram.addElement(new Hashtable()))
            _points.addElement(new Vector());

    }

    protected void _drawBar(Graphics g, int i, long l, long l1, boolean flag)
    {
        if(flag)
        {
            if(l1 < (long)super._uly)
                l1 = super._uly;
            if(l1 > (long)super._lry)
                l1 = super._lry;
        }
        if(l1 <= (long)super._lry && l <= (long)super._lrx && l >= (long)super._ulx)
        {
            int j = (int)(((double)l - (_barwidth * _binWidth * super._xscale) / 2D) + (double)i * _baroffset * _binWidth * super._xscale);
            int k = (int)((double)j + _barwidth * _binWidth * super._xscale);
            if(j < super._ulx)
                j = super._ulx;
            if(k > super._lrx)
                k = super._lrx;
            if(j >= k)
                k = j + 1;
            long l2 = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((long)super._lry < l2)
                l2 = super._lry;
            if((long)super._uly > l2)
                l2 = super._uly;
            if(super._yMin >= 0.0D || l1 <= l2)
                g.fillRect(j, (int)l1, k - j, (int)(l2 - l1));
            else
                g.fillRect(j, (int)l2, k - j, (int)(l1 - l2));
        }
    }

    protected synchronized void _drawPlot(Graphics g, boolean flag)
    {
        super._drawPlot(g, flag);
        _showing = true;
        for(int i = _points.size() - 1; i >= 0; i--)
        {
            Hashtable hashtable = (Hashtable)_histogram.elementAt(i);
            Integer integer;
            Integer integer1;
            for(Enumeration enumeration = hashtable.keys(); enumeration.hasMoreElements(); _drawPlotPoint(g, i, integer.intValue(), integer1.intValue()))
            {
                integer = (Integer)enumeration.nextElement();
                integer1 = (Integer)hashtable.get(integer);
            }

        }

    }

    protected synchronized void _drawPlot(Graphics g, boolean flag, Rectangle rectangle)
    {
        super._drawPlot(g, flag, rectangle);
        _showing = true;
        for(int i = _points.size() - 1; i >= 0; i--)
        {
            Hashtable hashtable = (Hashtable)_histogram.elementAt(i);
            Integer integer;
            Integer integer1;
            for(Enumeration enumeration = hashtable.keys(); enumeration.hasMoreElements(); _drawPlotPoint(g, i, integer.intValue(), integer1.intValue()))
            {
                integer = (Integer)enumeration.nextElement();
                integer1 = (Integer)hashtable.get(integer);
            }

        }

    }

    protected boolean _parseLine(String s)
    {
        if(super._parseLine(s))
            return true;
        String s1 = new String(s.toLowerCase());
        if(s1.startsWith("dataset:"))
        {
            _currentdataset++;
            if(s1.length() > 0)
            {
                String s2 = s.substring(8).trim();
                if(s2 != null && s2.length() > 0)
                    addLegend(_currentdataset, s2);
            }
            return true;
        }
        if(s1.startsWith("bars:") || s1.startsWith("bargraph:"))
        {
            int i = s.indexOf(",", 5);
            String s7 = null;
            String s5;
            if(i > 0)
            {
                s5 = s.substring(5, i).trim();
                s7 = s.substring(i + 1).trim();
            } else
            {
                s5 = s.substring(5).trim();
            }
            try
            {
                Double double5 = new Double(s5);
                double d = _baroffset;
                if(s7 != null)
                    d = (new Double(s7)).doubleValue();
                setBars(double5.doubleValue(), d);
            }
            catch(NumberFormatException numberformatexception4) { }
            return true;
        }
        if(s1.startsWith("binwidth:"))
        {
            String s3 = s.substring(9).trim();
            try
            {
                Double double1 = new Double(s3);
                setBinWidth(double1.doubleValue());
            }
            catch(NumberFormatException numberformatexception) { }
            return true;
        }
        if(s1.startsWith("binoffset:"))
        {
            String s4 = s.substring(10).trim();
            try
            {
                Double double2 = new Double(s4);
                setBinOffset(double2.doubleValue());
            }
            catch(NumberFormatException numberformatexception1) { }
            return true;
        }
        if(s1.startsWith("numsets:"))
            return true;
        if(s.startsWith("move:"))
            s = s.substring(5, s.length()).trim();
        else
        if(s.startsWith("move"))
            s = s.substring(4, s.length()).trim();
        else
        if(s.startsWith("draw:"))
            s = s.substring(5, s.length()).trim();
        else
        if(s.startsWith("draw"))
            s = s.substring(4, s.length()).trim();
        s = s.trim();
        int j = s.indexOf(",");
        if(j == -1)
            j = s.indexOf(" ");
        if(j == -1)
            j = s.indexOf("\t");
        if(j == -1)
        {
            try
            {
                Double double3 = new Double(s);
                addPoint(_currentdataset, double3.doubleValue());
                return true;
            }
            catch(NumberFormatException numberformatexception2) { }
        } else
        {
            String s6 = s.substring(j + 1).trim();
            try
            {
                Double double4 = new Double(s6);
                addPoint(_currentdataset, double4.doubleValue());
                return true;
            }
            catch(NumberFormatException numberformatexception3) { }
        }
        return false;
    }

    private void _addPoint(int i, double d)
    {
        _checkDatasetIndex(i);
        if(super.getLegend(i) == null)
            addLegend(i, "Current");
        int j = (int)Math.round((d - _binOffset) / _binWidth);
        Integer integer = new Integer(j);
        Hashtable hashtable = (Hashtable)_histogram.elementAt(i);
        int k;
        if(hashtable.containsKey(integer))
        {
            k = 1 + ((Integer)hashtable.get(integer)).intValue();
            hashtable.put(integer, new Integer(k));
        } else
        {
            k = 1;
            hashtable.put(integer, new Integer(k));
        }
        double d2 = (double)j * _binWidth + _binOffset;
        double d3 = d2 + _binWidth / 2D;
        if(d2 < super._xBottom)
            super._xBottom = d2;
        if(d3 > super._xTop)
            super._xTop = d3;
        if(super._ylog)
        {
            double d1 = Math.log(k) * PlotBox._LOG10SCALE;
            if(d1 > super._yTop)
                super._yTop = d1;
        } else
        if((double)k > super._yTop)
            super._yTop = k;
        super._yBottom = 0.0D;
        Vector vector = (Vector)_points.elementAt(i);
        vector.addElement(new Double(d));
        Graphics g = getGraphics();
        if(_showing && g != null)
        {
            int l = i;
            int i1 = j;
            int j1 = k;
            _drawPlotPoint(g, l, i1, j1);
        }
    }

    private void _clear(boolean flag)
    {
        super.clear(flag);
        _currentdataset = -1;
        _points = new Vector();
        _histogram = new Vector();
        _filename = null;
        _showing = false;
        if(flag)
        {
            _barwidth = 0.5D;
            _baroffset = 0.14999999999999999D;
            _binWidth = 1.0D;
            _binOffset = 0.5D;
        }
    }

    private void _drawPlotPoint(Graphics g, int i, int j, int k)
    {
        if(super._usecolor)
        {
            java.awt.Color color = super.getColor(i);
            g.setColor(color);
        } else
        {
            g.setColor(super._foreground);
        }
        double d = k;
        double d1 = _binWidth * (double)j + _binOffset;
        if(super._xlog)
        {
            if(d1 <= 0.0D)
            {
                System.err.println("Can't plot non-positive X values when the logarithmic X axis value is specified: " + d1);
                return;
            }
            d1 = Math.log(d1) * PlotBox._LOG10SCALE;
        }
        if(super._ylog)
        {
            if(_yIncremented)
                d++;
            if(d <= 0.0D)
            {
                System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + d);
                return;
            }
            d = Math.log(d) * PlotBox._LOG10SCALE;
        }
        long l = (long)super._lry - (long)((d - super._yMin) * super._yscale);
        long l1 = (long)super._ulx + (long)((d1 - super._xMin) * super._xscale);
        _drawBar(g, i, l1, l, true);
        g.setColor(super._foreground);
    }

    private void _fillPlot()
    {
        super.fillPlot();
        if(super._xBottom >= super._originalXlow)
            super._xBottom = super._xBottom - getBinWidth() / 2D;
        super.fillPlot();
    }

    protected int _currentdataset;
    protected Vector _points;
    protected Vector _histogram;
    private double _barwidth;
    private double _baroffset;
    private double _binWidth;
    private double _binOffset;
    private String _filename;
    private boolean _showing;
    private boolean _yIncremented;



}
