// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Plot.java

package voplot.ptolemy.plot;

import java.awt.*;
import java.io.*;
import java.net.URL;
import java.util.Vector;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            PlotBox, PlotPoint, EPSGraphics

public class Plot extends PlotBox
{
    private class Format
        implements Serializable
    {

        public boolean connected;
        public boolean connectedUseDefault;
        public boolean impulses;
        public boolean impulsesUseDefault;
        public int marks;
        public boolean marksUseDefault;

        private Format()
        {
            connectedUseDefault = true;
            impulsesUseDefault = true;
            marksUseDefault = true;
        }

    }


    public Plot()
    {
        _points = new Vector();
        _currentdataset = -1;
        _marks = 3;
        _pointsPersistence = 0;
        _xPersistence = 0.0D;
        _bars = false;
        barWidth = 0.5D;
        _barOffset = 0.050000000000000003D;
        _connected = false;
        _impulses = false;
        _maxDataset = -1;
        _reuseDatasets = false;
        _firstInSet = true;
        _sawFirstDataSet = false;
        _radius = 3;
        _diameter = 6;
        _prevx = new Vector();
        _prevy = new Vector();
        _xyInvalid = true;
        _filename = null;
        _showing = false;
        _formats = new Vector();
    }

    public synchronized void addLegend(int i, String s)
    {
        _checkDatasetIndex(i);
        super.addLegend(i, s);
    }

    public synchronized void addPoint(final int dataset, final double x, final double y, final String oid, final boolean connected)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _addPoint(dataset, x, y, 0.0D, 0.0D, connected, false, false, oid);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void addPointWithErrorBars(final int dataset, final double x, final double y, final double yLowEB, 
            final double yHighEB, final String oid, final boolean connected)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _addPoint(dataset, x, y, yLowEB, yHighEB, connected, true, false, oid);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void addPointWithErrorBars(int i, double d, double d1, double d2, 
            double d3, String s, boolean flag, boolean flag1)
    {
        if(flag1)
            _addPoint(i, d, d1, d2, d3, flag, true, true, s);
        else
            addPointWithErrorBars(i, d, d1, d2, d3, s, flag);
    }

    public synchronized void clear(final boolean format)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _clear(format);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void clear(boolean flag, boolean flag1)
    {
        if(flag1)
            _clear(flag);
        else
            clear(flag);
    }

    public synchronized void clear(final int dataset)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _clear(dataset);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void clear(int i, boolean flag)
    {
        if(flag)
            _clear(i);
        else
            clear(i);
    }

    public synchronized void erasePoint(final int dataset, final int index)
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _erasePoint(dataset, index);
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void erasePoint(int i, int j, boolean flag)
    {
        if(flag)
            _erasePoint(i, j);
        else
            erasePoint(i, j);
    }

    public synchronized void fillPlot()
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                _fillPlot();
            }

        };
        deferIfNecessary(runnable);
    }

    public synchronized void fillPlot(boolean flag)
    {
        if(flag)
            _fillPlot();
        else
            fillPlot();
    }

    public boolean getConnected()
    {
        return _connected;
    }

    public boolean getImpulses()
    {
        return _impulses;
    }

    public synchronized String getMarksStyle()
    {
        if(_marks == 0)
            return "none";
        if(_marks == 1)
            return "points";
        if(_marks == 2)
            return "dots";
        if(_marks == 3)
            return "various";
        else
            return "pixels";
    }

    /**
     * @deprecated Method getMaxDataSets is deprecated
     */

    public int getMaxDataSets()
    {
        return 0x7fffffff;
    }

    public synchronized int getNumDataSets()
    {
        return _points.size();
    }

    /**
     * @deprecated Method parseFile is deprecated
     */

    public void parseFile(String s, URL url)
    {
        _firstInSet = true;
        _sawFirstDataSet = false;
        super.parseFile(s, url);
    }

    public synchronized void read(InputStream inputstream)
        throws IOException
    {
        super.read(inputstream);
        _firstInSet = true;
        _sawFirstDataSet = false;
    }

    public synchronized void samplePlot()
    {
        Runnable runnable = new Runnable() {

            public void run()
            {
                synchronized(Plot.this)
                {
                    clear(true);
                    setTitle("Sample plot");
                    setYRange(-4D, 4D);
                    setXRange(0.0D, 100D);
                    setXLabel("time");
                    setYLabel("value");
                    addYTick("-PI", -3.1415926535897931D);
                    addYTick("-PI/2", -1.5707963267948966D);
                    addYTick("0", 0.0D);
                    addYTick("PI/2", 1.5707963267948966D);
                    addYTick("PI", 3.1415926535897931D);
                    setMarksStyle("none");
                    setImpulses(true);
                    boolean flag = true;
                    for(int i = 0; i <= 100; i++)
                    {
                        double d = i;
                        addPoint(0, d, 5D * Math.cos((3.1415926535897931D * (double)i) / 20D), "x", !flag);
                        addPoint(1, d, 4.5D * Math.cos((3.1415926535897931D * (double)i) / 25D), "x", !flag);
                        addPoint(2, d, 4D * Math.cos((3.1415926535897931D * (double)i) / 30D), "x", !flag);
                        addPoint(3, d, 3.5D * Math.cos((3.1415926535897931D * (double)i) / 35D), "x", !flag);
                        addPoint(4, d, 3D * Math.cos((3.1415926535897931D * (double)i) / 40D), "x", !flag);
                        addPoint(5, d, 2.5D * Math.cos((3.1415926535897931D * (double)i) / 45D), "x", !flag);
                        addPoint(6, d, 2D * Math.cos((3.1415926535897931D * (double)i) / 50D), "x", !flag);
                        addPoint(7, d, 1.5D * Math.cos((3.1415926535897931D * (double)i) / 55D), "x", !flag);
                        addPoint(8, d, 1.0D * Math.cos((3.1415926535897931D * (double)i) / 60D), "x", !flag);
                        addPoint(9, d, 0.5D * Math.cos((3.1415926535897931D * (double)i) / 65D), "x", !flag);
                        flag = false;
                    }

                }
                repaint();
            }

        };
        deferIfNecessary(runnable);
    }

    public void setBars(boolean flag)
    {
        _bars = flag;
    }

    public synchronized void setBars(double d, double d1)
    {
        barWidth = d;
        _barOffset = d1;
        _bars = true;
    }

    public void setConnected(boolean flag)
    {
        _connected = flag;
    }

    public synchronized void setConnected(boolean flag, int i)
    {
        _checkDatasetIndex(i);
        Format format = (Format)_formats.elementAt(i);
        format.connected = flag;
        format.connectedUseDefault = false;
    }

    public synchronized void setImpulses(boolean flag)
    {
        _impulses = flag;
    }

    public synchronized void setImpulses(boolean flag, int i)
    {
        _checkDatasetIndex(i);
        Format format = (Format)_formats.elementAt(i);
        format.impulses = flag;
        format.impulsesUseDefault = false;
    }

    public synchronized void setMarksStyle(String s)
    {
        if(s.equalsIgnoreCase("none"))
            _marks = 0;
        else
        if(s.equalsIgnoreCase("points"))
            _marks = 1;
        else
        if(s.equalsIgnoreCase("dots"))
            _marks = 2;
        else
        if(s.equalsIgnoreCase("various"))
            _marks = 3;
        else
        if(s.equalsIgnoreCase("pixels"))
            _marks = 4;
    }

    public synchronized void setMarksStyle(String s, int i)
    {
        _checkDatasetIndex(i);
        Format format = (Format)_formats.elementAt(i);
        if(s.equalsIgnoreCase("none"))
            format.marks = 0;
        else
        if(s.equalsIgnoreCase("points"))
            format.marks = 1;
        else
        if(s.equalsIgnoreCase("dots"))
            format.marks = 2;
        else
        if(s.equalsIgnoreCase("various"))
            format.marks = 3;
        else
        if(s.equalsIgnoreCase("pixels"))
            format.marks = 4;
        format.marksUseDefault = false;
    }

    /**
     * @deprecated Method setNumSets is deprecated
     */

    public void setNumSets(int i)
    {
        if(i < 1)
            throw new IllegalArgumentException("Number of data sets (" + i + ") must be greater than 0.");
        _currentdataset = -1;
        _points.removeAllElements();
        _formats.removeAllElements();
        _prevx.removeAllElements();
        _prevy.removeAllElements();
        for(int j = 0; j < i; j++)
        {
            _points.addElement(new Vector());
            _formats.addElement(new Format());
            _prevx.addElement(new Long(0L));
            _prevy.addElement(new Long(0L));
        }

    }

    public void setPointsPersistence(int i)
    {
        _pointsPersistence = i;
    }

    public void setReuseDatasets(boolean flag)
    {
        _reuseDatasets = flag;
    }

    public void setXPersistence(double d)
    {
        _xPersistence = d;
    }

    public synchronized void writeData(PrintWriter printwriter)
    {
        super.writeData(printwriter);
        for(int i = 0; i < _points.size(); i++)
        {
            StringBuffer stringbuffer = new StringBuffer();
            Format format = (Format)_formats.elementAt(i);
            if(!format.connectedUseDefault)
                if(_isConnected(i))
                    stringbuffer.append(" connected=\"yes\"");
                else
                    stringbuffer.append(" connected=\"no\"");
            if(!format.impulsesUseDefault)
                if(format.impulses)
                    stringbuffer.append(" stems=\"yes\"");
                else
                    printwriter.println(" stems=\"no\"");
            if(!format.marksUseDefault)
                switch(format.marks)
                {
                case 0: // '\0'
                    stringbuffer.append(" marks=\"none\"");
                    // fall through

                case 1: // '\001'
                    stringbuffer.append(" marks=\"points\"");
                    // fall through

                case 2: // '\002'
                    stringbuffer.append(" marks=\"dots\"");
                    // fall through

                case 3: // '\003'
                    stringbuffer.append(" marks=\"various\"");
                    // fall through

                case 4: // '\004'
                    stringbuffer.append(" marks=\"pixels\"");
                    break;
                }
            String s = getLegend(i);
            if(s != null)
                stringbuffer.append(" name=\"" + getLegend(i) + "\"");
            printwriter.println("<dataset" + stringbuffer.toString() + ">");
            Vector vector = (Vector)_points.elementAt(i);
            for(int j = 0; j < vector.size(); j++)
            {
                PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
                if(!plotpoint.connected)
                    printwriter.print("<m ");
                else
                    printwriter.print("<p ");
                printwriter.print("x=\"" + plotpoint.x + "\" y=\"" + plotpoint.y + "\"");
                if(plotpoint.errorBar)
                    printwriter.print(" lowErrorBar=\"" + plotpoint.yLowEB + "\" highErrorBar=\"" + plotpoint.yHighEB + "\"");
                printwriter.println("/>");
            }

            printwriter.println("</dataset>");
        }

    }

    public synchronized void writeFormat(PrintWriter printwriter)
    {
        super.writeFormat(printwriter);
        if(_reuseDatasets)
            printwriter.println("<reuseDatasets/>");
        StringBuffer stringbuffer = new StringBuffer();
        if(!_connected)
            stringbuffer.append(" connected=\"no\"");
        switch(_marks)
        {
        case 1: // '\001'
            stringbuffer.append(" marks=\"points\"");
            break;

        case 2: // '\002'
            stringbuffer.append(" marks=\"dots\"");
            break;

        case 3: // '\003'
            stringbuffer.append(" marks=\"various\"");
            break;

        case 4: // '\004'
            stringbuffer.append(" marks=\"pixels\"");
            break;
        }
        if(_impulses)
            stringbuffer.append(" stems=\"yes\"");
        if(stringbuffer.length() > 0)
            printwriter.println("<default" + stringbuffer.toString() + "/>");
        if(_bars)
            printwriter.println("<barGraph width=\"" + barWidth + "\" offset=\"" + _barOffset + "\"/>");
    }

    protected synchronized void _checkDatasetIndex(int i)
    {
        if(i < 0)
            throw new IllegalArgumentException("Plot._checkDatasetIndex: Cannot give a negative number for the data set index.");
        for(; i >= _points.size(); _prevy.addElement(new Long(0L)))
        {
            _points.addElement(new Vector());
            _formats.addElement(new Format());
            _prevx.addElement(new Long(0L));
        }

    }

    protected void _drawBar(Graphics g, int i, long l, long l1, boolean flag)
    {
        if(flag)
        {
            if(l1 < (long)super._uly)
                l1 = super._uly;
            if(l1 > (long)super._lry)
                l1 = super._lry;
        }
        if(l1 <= (long)super._lry && l <= (long)super._lrx && l >= (long)super._ulx)
        {
            int j = (int)(((double)l - (barWidth * super._xscale) / 2D) + (double)i * _barOffset * super._xscale);
            int k = (int)((double)j + barWidth * super._xscale);
            if(j < super._ulx)
                j = super._ulx;
            if(k > super._lrx)
                k = super._lrx;
            if(j >= k)
                k = j + 1;
            long l2 = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((long)super._lry < l2)
                l2 = super._lry;
            if((long)super._uly > l2)
                l2 = super._uly;
            if(super._yMin >= 0.0D || l1 <= l2)
                g.fillRect(j, (int)l1, k - j, (int)(l2 - l1));
            else
                g.fillRect(j, (int)l2, k - j, (int)(l1 - l2));
        }
    }

    protected void _drawErrorBar(Graphics g, int i, long l, long l1, long l2, boolean flag)
    {
        _drawLine(g, i, l - 5L, l2, l + 5L, l2, flag);
        _drawLine(g, i, l, l1, l, l2, flag);
        _drawLine(g, i, l - 5L, l1, l + 5L, l1, flag);
    }

    protected void _drawImpulse(Graphics g, long l, long l1, boolean flag)
    {
        if(flag)
        {
            if(l1 < (long)super._uly)
                l1 = super._uly;
            if(l1 > (long)super._lry)
                l1 = super._lry;
        }
        if(l1 <= (long)super._lry && l <= (long)super._lrx && l >= (long)super._ulx)
        {
            double d = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((double)super._lry < d)
                d = super._lry;
            if((double)super._uly > d)
                d = super._uly;
            g.drawLine((int)l, (int)l1, (int)l, (int)d);
        }
    }

    protected void _drawLine(Graphics g, int i, long l, long l1, long l2, long l3, boolean flag)
    {
        if(flag)
        {
            if((l2 > (long)super._ulx || l > (long)super._ulx) && (l2 < (long)super._lrx || l < (long)super._lrx) && (l3 > (long)super._uly || l1 > (long)super._uly) && (l3 < (long)super._lry || l1 < (long)super._lry))
            {
                if(l != l2)
                    if(l2 < (long)super._ulx)
                    {
                        l3 = (int)(l3 + ((l1 - l3) * ((long)super._ulx - l2)) / (l - l2));
                        l2 = super._ulx;
                    } else
                    if(l2 > (long)super._lrx)
                    {
                        l3 = (int)(l3 + ((l1 - l3) * ((long)super._lrx - l2)) / (l - l2));
                        l2 = super._lrx;
                    }
                if(l1 != l3)
                    if(l3 < (long)super._uly)
                    {
                        l2 = (int)(l2 + ((l - l2) * ((long)super._uly - l3)) / (l1 - l3));
                        l3 = super._uly;
                    } else
                    if(l3 > (long)super._lry)
                    {
                        l2 = (int)(l2 + ((l - l2) * ((long)super._lry - l3)) / (l1 - l3));
                        l3 = super._lry;
                    }
                if(l != l2)
                    if(l < (long)super._ulx)
                    {
                        l1 = (int)(l1 + ((l3 - l1) * ((long)super._ulx - l)) / (l2 - l));
                        l = super._ulx;
                    } else
                    if(l > (long)super._lrx)
                    {
                        l1 = (int)(l1 + ((l3 - l1) * ((long)super._lrx - l)) / (l2 - l));
                        l = super._lrx;
                    }
                if(l1 != l3)
                    if(l1 < (long)super._uly)
                    {
                        l = (int)(l + ((l2 - l) * ((long)super._uly - l1)) / (l3 - l1));
                        l1 = super._uly;
                    } else
                    if(l1 > (long)super._lry)
                    {
                        l = (int)(l + ((l2 - l) * ((long)super._lry - l1)) / (l3 - l1));
                        l1 = super._lry;
                    }
            }
            if(l2 >= (long)super._ulx && l2 <= (long)super._lrx && l3 >= (long)super._uly && l3 <= (long)super._lry && l >= (long)super._ulx && l <= (long)super._lrx && l1 >= (long)super._uly && l1 <= (long)super._lry)
                g.drawLine((int)l, (int)l1, (int)l2, (int)l3);
        } else
        {
            g.drawLine((int)l, (int)l1, (int)l2, (int)l3);
        }
    }

    protected synchronized void _drawPlot(Graphics g, boolean flag, Rectangle rectangle)
    {
        super._drawPlot(g, flag, rectangle);
        for(int i = _points.size() - 1; i >= 0; i--)
        {
            Vector vector = (Vector)_points.elementAt(i);
            Vector vector1 = new Vector();
            for(int j = 0; j < vector.size(); j++)
            {
                PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
                if(!plotpoint.highlighted)
                    _drawPlotPoint(g, i, j);
                else
                    vector1.add(new Integer(j));
            }

            for(int k = 0; k < vector1.size(); k++)
            {
                int l = ((Integer)vector1.get(k)).intValue();
                PlotPoint plotpoint1 = (PlotPoint)vector.elementAt(l);
                if(plotpoint1.highlighted)
                    _drawPlotPoint(g, i, l);
            }

        }

        _showing = true;
    }

    protected void _drawPoint(Graphics g, int i, long l, long l1, boolean flag, 
            boolean flag1, boolean flag2)
    {
        boolean flag3 = l1 <= (long)super._lry && l1 >= (long)super._uly && l <= (long)super._lrx && l >= (long)super._ulx;
        if(!flag || flag3)
        {
            int j = (int)l;
            int k = (int)l1;
            Format format = (Format)_formats.elementAt(i);
            int i1 = _marks;
            if(!format.marksUseDefault)
                i1 = format.marks;
            if(!flag3 && i1 != 3 && _isConnected(i) && (g instanceof EPSGraphics))
            {
                g.drawLine(j - 6, k, j + 6, k);
            } else
            {
                Color color = g.getColor();
                Color color1;
                if(flag2)
                {
                    color1 = HIGHLIGHT_COLOR;
                    g.setColor(color1);
                } else
                {
                    color1 = color;
                }
                switch(i1)
                {
                case 0: // '\0'
                    g.fillRect(j - 6, k - 6, 6, 6);
                    break;

                case 1: // '\001'
                    if(flag1)
                    {
                        g.setColor(new Color(43690));
                        g.drawRect(j - 3, k - 3, 6, 6);
                        g.setColor(color1);
                    }
                    g.fillOval(j - 1, k - 1, 3, 3);
                    break;

                case 2: // '\002'
                    if(flag1)
                    {
                        g.setColor(new Color(43690));
                        g.drawRect(j - 4, k - 4, 8, 8);
                        g.setColor(color1);
                    }
                    g.fillOval(j - _radius, k - _radius, _diameter, _diameter);
                    break;

                case 3: // '\003'
                    if(flag1)
                    {
                        g.setColor(new Color(43690));
                        g.drawRect(j - 4, k - 4, 8, 8);
                        g.setColor(color1);
                    }
                    int j1 = super.getMarkerStyle(i);
                    switch(j1)
                    {
                    case 0: // '\0'
                        g.fillOval(j - _radius, k - _radius, _diameter, _diameter);
                        break;

                    case 1: // '\001'
                        g.drawLine(j - _radius, k - _radius, j + _radius, k + _radius);
                        g.drawLine(j + _radius, k - _radius, j - _radius, k + _radius);
                        break;

                    case 2: // '\002'
                        g.drawRect((j - _radius) + 1, (k - _radius) + 1, _diameter - 2, _diameter - 2);
                        g.drawLine((j - _radius) + 1, (k - _radius) + 1, (j + _radius) - 1, (k + _radius) - 1);
                        g.drawLine((j + _radius) - 1, (k - _radius) + 1, (j - _radius) + 1, (k + _radius) - 1);
                        break;

                    case 3: // '\003'
                        int ai[] = new int[4];
                        int ai4[] = new int[4];
                        ai[0] = j;
                        ai4[0] = k - _radius;
                        ai[1] = j + _radius;
                        ai4[1] = k + _radius;
                        ai[2] = j - _radius;
                        ai4[2] = k + _radius;
                        ai[3] = j;
                        ai4[3] = k - _radius;
                        g.fillPolygon(ai, ai4, 4);
                        break;

                    case 4: // '\004'
                        int ai1[] = new int[5];
                        int ai5[] = new int[5];
                        ai1[0] = j;
                        ai5[0] = k - _radius;
                        ai1[1] = j + _radius;
                        ai5[1] = k;
                        ai1[2] = j;
                        ai5[2] = k + _radius;
                        ai1[3] = j - _radius;
                        ai5[3] = k;
                        ai1[4] = j;
                        ai5[4] = k - _radius;
                        g.drawPolygon(ai1, ai5, 5);
                        break;

                    case 5: // '\005'
                        g.drawOval(j - _radius, k - _radius, _diameter, _diameter);
                        break;

                    case 6: // '\006'
                        g.drawLine(j, k - _radius, j, k + _radius);
                        g.drawLine(j - _radius, k, j + _radius, k);
                        break;

                    case 7: // '\007'
                        g.fillRect(j - _radius, k - _radius, _diameter, _diameter);
                        break;

                    case 8: // '\b'
                        int ai2[] = new int[4];
                        int ai6[] = new int[4];
                        ai2[0] = j;
                        ai6[0] = k - _radius;
                        ai2[1] = j + _radius;
                        ai6[1] = k + _radius;
                        ai2[2] = j - _radius;
                        ai6[2] = k + _radius;
                        ai2[3] = j;
                        ai6[3] = k - _radius;
                        g.drawPolygon(ai2, ai6, 4);
                        break;

                    case 9: // '\t'
                        int ai3[] = new int[5];
                        int ai7[] = new int[5];
                        ai3[0] = j;
                        ai7[0] = k - _radius;
                        ai3[1] = j + _radius;
                        ai7[1] = k;
                        ai3[2] = j;
                        ai7[2] = k + _radius;
                        ai3[3] = j - _radius;
                        ai7[3] = k;
                        ai3[4] = j;
                        ai7[4] = k - _radius;
                        g.fillPolygon(ai3, ai7, 5);
                        break;
                    }
                    break;

                case 4: // '\004'
                    if(flag1)
                    {
                        g.setColor(new Color(43690));
                        g.drawRect(j - 2, k - 2, 4, 4);
                        g.setColor(color1);
                    }
                    g.fillRect(j, k, 1, 1);
                    break;

                default:
                    g.setColor(color);
                    break;
                }
            }
        }
    }

    protected boolean _parseLine(String s)
    {
        boolean flag = false;
        if(_isConnected(_currentdataset))
            flag = true;
        if(super._parseLine(s))
            return true;
        String s1 = new String(s.toLowerCase());
        if(s1.startsWith("marks:"))
        {
            String s2 = s.substring(6).trim();
            if(_sawFirstDataSet)
                setMarksStyle(s2, _currentdataset);
            else
                setMarksStyle(s2);
            return true;
        }
        if(s1.startsWith("numsets:"))
            return true;
        if(s1.startsWith("reusedatasets:"))
        {
            if(s1.indexOf("off", 16) >= 0)
                setReuseDatasets(false);
            else
                setReuseDatasets(true);
            return true;
        }
        if(s1.startsWith("dataset:"))
        {
            if(_reuseDatasets && s1.length() > 0)
            {
                String s3 = s.substring(8).trim();
                _currentdataset = -1;
                for(int k = 0; k <= _maxDataset; k++)
                    if(getLegend(k).compareTo(s3) == 0)
                        _currentdataset = k;

                if(_currentdataset != -1)
                    return true;
                _currentdataset = _maxDataset;
            }
            _firstInSet = true;
            _sawFirstDataSet = true;
            _currentdataset++;
            if(s1.length() > 0)
            {
                String s4 = s.substring(8).trim();
                if(s4 != null && s4.length() > 0)
                    addLegend(_currentdataset, s4);
            }
            _maxDataset = _currentdataset;
            return true;
        }
        if(s1.startsWith("lines:"))
        {
            if(s1.indexOf("off", 6) >= 0)
                setConnected(false);
            else
                setConnected(true);
            return true;
        }
        if(s1.startsWith("impulses:"))
        {
            if(_sawFirstDataSet)
            {
                if(s1.indexOf("off", 9) >= 0)
                    setImpulses(false, _currentdataset);
                else
                    setImpulses(true, _currentdataset);
            } else
            if(s1.indexOf("off", 9) >= 0)
                setImpulses(false);
            else
                setImpulses(true);
            return true;
        }
        if(s1.startsWith("bars:"))
        {
            if(s1.indexOf("off", 5) >= 0)
            {
                setBars(false);
            } else
            {
                setBars(true);
                int i = s.indexOf(",", 5);
                String s7 = null;
                String s5;
                if(i > 0)
                {
                    s5 = s.substring(5, i).trim();
                    s7 = s.substring(i + 1).trim();
                } else
                {
                    s5 = s.substring(5).trim();
                }
                try
                {
                    Double double1 = new Double(s5);
                    double d = _barOffset;
                    if(s7 != null)
                        d = (new Double(s7)).doubleValue();
                    setBars(double1.doubleValue(), d);
                }
                catch(NumberFormatException numberformatexception) { }
            }
            return true;
        }
        if(s.startsWith("move:"))
        {
            flag = false;
            s = s.substring(5, s.length()).trim();
        } else
        if(s.startsWith("move"))
        {
            flag = false;
            s = s.substring(4, s.length()).trim();
        } else
        if(s.startsWith("draw:"))
            s = s.substring(5, s.length()).trim();
        else
        if(s.startsWith("draw"))
            s = s.substring(4, s.length()).trim();
        s = s.trim();
        int j = s.indexOf(",");
        if(j == -1)
            j = s.indexOf(" ");
        if(j == -1)
            j = s.indexOf("\t");
        if(j > 0)
        {
            String s6 = s.substring(0, j).trim();
            String s8 = s.substring(j + 1).trim();
            int l = s8.indexOf(",");
            if(l == -1)
                l = s8.indexOf(" ");
            if(l == -1)
                l = s8.indexOf("\t");
            if(l > 0)
            {
                s = s8.substring(l + 1).trim();
                s8 = s8.substring(0, l).trim();
            }
            try
            {
                Double double2 = new Double(s6);
                Double double3 = new Double(s8);
                if(l > 0)
                {
                    int j1 = s.indexOf(",");
                    if(j1 == -1)
                        j1 = s.indexOf(" ");
                    int i1;
                    if(j1 == -1)
                        i1 = s.indexOf("\t");
                    if(j1 > 0)
                    {
                        String s9 = s.substring(0, j1).trim();
                        String s10 = s.substring(j1 + 1).trim();
                        Double double4 = new Double(s9);
                        Double double5 = new Double(s10);
                        flag = _addLegendIfNecessary(flag);
                        addPointWithErrorBars(_currentdataset, double2.doubleValue(), double3.doubleValue(), double4.doubleValue(), double5.doubleValue(), "x", flag);
                        return true;
                    } else
                    {
                        flag = _addLegendIfNecessary(flag);
                        addPoint(_currentdataset, double2.doubleValue(), double3.doubleValue(), "x", flag);
                        return true;
                    }
                } else
                {
                    flag = _addLegendIfNecessary(flag);
                    addPoint(_currentdataset, double2.doubleValue(), double3.doubleValue(), "x", flag);
                    return true;
                }
            }
            catch(NumberFormatException numberformatexception1) { }
        }
        return false;
    }

    /**
     * @deprecated Method _writeOldSyntax is deprecated
     */

    protected void _writeOldSyntax(PrintWriter printwriter)
    {
        super._writeOldSyntax(printwriter);
        if(_reuseDatasets)
            printwriter.println("ReuseDatasets: on");
        if(!_connected)
            printwriter.println("Lines: off");
        if(_bars)
            printwriter.println("Bars: " + barWidth + ", " + _barOffset);
        if(_impulses)
            printwriter.println("Impulses: on");
        int i;
        switch(_marks)
        {
        case 1: // '\001'
            printwriter.println("Marks: points");
            // fall through

        case 2: // '\002'
            printwriter.println("Marks: dots");
            // fall through

        case 3: // '\003'
            printwriter.println("Marks: various");
            // fall through

        case 4: // '\004'
            printwriter.println("Marks: pixels");
            // fall through

        default:
            i = 0;
            break;
        }
        for(; i < _points.size(); i++)
        {
            String s = getLegend(i);
            if(s != null)
                printwriter.println("DataSet: " + getLegend(i));
            else
                printwriter.println("DataSet:");
            Format format = (Format)_formats.elementAt(i);
            if(!format.impulsesUseDefault)
                if(format.impulses)
                    printwriter.println("Impulses: on");
                else
                    printwriter.println("Impulses: off");
            if(!format.marksUseDefault)
                switch(format.marks)
                {
                case 0: // '\0'
                    printwriter.println("Marks: none");
                    // fall through

                case 1: // '\001'
                    printwriter.println("Marks: points");
                    // fall through

                case 2: // '\002'
                    printwriter.println("Marks: dots");
                    // fall through

                case 3: // '\003'
                    printwriter.println("Marks: various");
                    // fall through

                case 4: // '\004'
                    printwriter.println("Marks: pixels");
                    break;
                }
            Vector vector = (Vector)_points.elementAt(i);
            for(int j = 0; j < vector.size(); j++)
            {
                PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
                if(!plotpoint.connected)
                    printwriter.print("move: ");
                if(plotpoint.errorBar)
                    printwriter.println(plotpoint.x + ", " + plotpoint.y + ", " + plotpoint.yLowEB + ", " + plotpoint.yHighEB);
                else
                    printwriter.println(plotpoint.x + ", " + plotpoint.y);
            }

        }

    }

    private boolean _addLegendIfNecessary(boolean flag)
    {
        if((!_sawFirstDataSet || _currentdataset < 0) && !_reuseDatasets)
        {
            _sawFirstDataSet = true;
            _currentdataset++;
        }
        if(!_sawFirstDataSet && getLegend(_currentdataset) == null)
        {
            _firstInSet = true;
            _sawFirstDataSet = true;
            addLegend(_currentdataset, new String("Set " + _currentdataset));
        }
        if(_firstInSet && !_reuseDatasets)
        {
            flag = false;
            _firstInSet = false;
        }
        return flag;
    }

    private void _addPoint(int i, double d, double d1, double d2, 
            double d3, boolean flag, boolean flag1, boolean flag2, String s)
    {
        _checkDatasetIndex(i);
        if(super.getLegend(i) == null)
            addLegend(i, "Current");
        if(super._xlog)
        {
            if(d <= 0.0D)
            {
                System.err.println("Can't plot non-positive X values when the logarithmic X axis value is specified: " + d);
                return;
            }
            d = Math.log(d) * PlotBox._LOG10SCALE;
        }
        if(super._ylog)
        {
            if(d1 <= 0.0D)
            {
                System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + d1);
                return;
            }
            d1 = Math.log(d1) * PlotBox._LOG10SCALE;
            if(flag1)
            {
                if(d2 <= 0.0D || d3 <= 0.0D)
                {
                    System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + d1);
                    return;
                }
                d2 = Math.log(d2) * PlotBox._LOG10SCALE;
                d3 = Math.log(d3) * PlotBox._LOG10SCALE;
            }
        }
        Vector vector = (Vector)_points.elementAt(i);
        if(_xPersistence > 0.0D)
        {
            int j;
            for(j = 0; j < vector.size(); j++)
            {
                PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
                if(d - plotpoint.originalx <= _xPersistence)
                    break;
            }

            for(int l = 0; l < j; l++)
                erasePoint(i, 0, flag2);

        }
        int k = vector.size();
        PlotPoint plotpoint1 = new PlotPoint();
        plotpoint1.originalx = d;
        if(super._wrap)
        {
            double d4 = super._wrapHigh - super._wrapLow;
            if(d < super._wrapLow)
                d += d4 * Math.floor(1.0D + (super._wrapLow - d) / d4);
            else
            if(d > super._wrapHigh)
            {
                d -= d4 * Math.floor(1.0D + (d - super._wrapHigh) / d4);
                if(d == super._wrapLow)
                    d = super._wrapHigh;
            }
        }
        if(d < super._xBottom)
            super._xBottom = d;
        if(d > super._xTop)
            super._xTop = d;
        if(d1 < super._yBottom)
            super._yBottom = d1;
        if(d1 > super._yTop)
            super._yTop = d1;
        plotpoint1.x = d;
        plotpoint1.y = d1;
        plotpoint1.connected = flag && _isConnected(i);
        plotpoint1.objectID = s;
        if(flag1)
        {
            if(d2 < super._yBottom)
                super._yBottom = d2;
            if(d2 > super._yTop)
                super._yTop = d2;
            if(d3 < super._yBottom)
                super._yBottom = d3;
            if(d3 > super._yTop)
                super._yTop = d3;
            plotpoint1.yLowEB = d2;
            plotpoint1.yHighEB = d3;
            plotpoint1.errorBar = true;
        }
        if(k == 0)
            plotpoint1.connected = false;
        else
        if(super._wrap)
        {
            PlotPoint plotpoint2 = (PlotPoint)vector.elementAt(k - 1);
            if(plotpoint2.x > d)
                plotpoint1.connected = false;
        }
        vector.addElement(plotpoint1);
        if(_pointsPersistence > 0 && k > _pointsPersistence)
            erasePoint(i, 0, flag2);
        Graphics g = getGraphics();
        if(_showing && g != null)
        {
            if((_pointsPersistence > 0 || _xPersistence > 0.0D) && isDoubleBuffered())
            {
                setDoubleBuffered(false);
                for(java.awt.Container container = getParent(); container != null; container = container.getParent())
                    if(container instanceof JComponent)
                        ((JComponent)container).setDoubleBuffered(false);

            }
            _drawPlotPoint(g, i, vector.size() - 1);
        }
        if(super._wrap && d == super._wrapHigh)
            _addPoint(i, super._wrapLow, d1, d2, d3, false, flag1, flag2, "x");
    }

    private void _clear(boolean flag)
    {
        super.clear(flag);
        _currentdataset = -1;
        int i = _points.size();
        _points = new Vector();
        _prevx = new Vector();
        _prevy = new Vector();
        _maxDataset = -1;
        _firstInSet = true;
        _sawFirstDataSet = false;
        _xyInvalid = true;
        _filename = null;
        if(flag)
        {
            _showing = false;
            _formats = new Vector();
            _marks = 3;
            _pointsPersistence = 0;
            _xPersistence = 0.0D;
            _bars = false;
            barWidth = 0.5D;
            _barOffset = 0.050000000000000003D;
            _connected = false;
            _impulses = false;
            _reuseDatasets = false;
        }
    }

    private void _clear(int i)
    {
        _checkDatasetIndex(i);
        _xyInvalid = true;
        Vector vector = (Vector)_points.elementAt(i);
        _points.setElementAt(new Vector(), i);
        repaint();
    }

    private void _drawPlotPoint(Graphics g, int i, int j)
    {
        if(_pointsPersistence > 0 || _xPersistence > 0.0D)
            if(super._background == null)
                g.setXORMode(getBackground());
            else
                g.setXORMode(super._background);
        if(super._usecolor)
        {
            Color color = super.getColor(i);
            g.setColor(color);
        } else
        {
            g.setColor(super._foreground);
        }
        Vector vector = (Vector)_points.elementAt(i);
        PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
        long l = (long)super._lry - (long)((plotpoint.y - super._yMin) * super._yscale);
        long l1 = (long)super._ulx + (long)((plotpoint.x - super._xMin) * super._xscale);
        if(super._yReverse)
            l = (long)(super._lry + super._uly) - l;
        if(super._xReverse)
            l1 = (long)(super._lrx + super._ulx) - l1;
        long l2 = ((Long)_prevx.elementAt(i)).longValue();
        long l3 = ((Long)_prevy.elementAt(i)).longValue();
        if(plotpoint.connected)
            _drawLine(g, i, l1, l, l2, l3, true);
        _prevx.setElementAt(new Long(l1), i);
        _prevy.setElementAt(new Long(l), i);
        Format format = (Format)_formats.elementAt(i);
        if(format.impulsesUseDefault)
        {
            if(_impulses)
                _drawImpulse(g, l1, l, true);
        } else
        if(format.impulses)
            _drawImpulse(g, l1, l, true);
        int k = _marks;
        if(!format.marksUseDefault)
            k = format.marks;
        if(k != 0)
            _drawPoint(g, i, l1, l, true, plotpoint.selected, plotpoint.highlighted);
        if(_bars)
            _drawBar(g, i, l1, l, true);
        if(plotpoint.errorBar)
            _drawErrorBar(g, i, l1, (long)super._lry - (long)((plotpoint.yLowEB - super._yMin) * super._yscale), (long)super._lry - (long)((plotpoint.yHighEB - super._yMin) * super._yscale), true);
        g.setColor(super._foreground);
        if(_pointsPersistence > 0 || _xPersistence > 0.0D)
            g.setPaintMode();
    }

    private void _erasePoint(int i, int j)
    {
        _checkDatasetIndex(i);
        Graphics g = getGraphics();
        if(_showing && g != null)
        {
            if(_pointsPersistence > 0 || _xPersistence > 0.0D)
                if(super._background == null)
                    g.setXORMode(getBackground());
                else
                    g.setXORMode(super._background);
            if(super._usecolor)
            {
                Color color = super.getColor(i);
                g.setColor(color);
            } else
            {
                g.setColor(super._foreground);
            }
            Vector vector = (Vector)_points.elementAt(i);
            PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
            long l = (long)super._lry - (long)((plotpoint.y - super._yMin) * super._yscale);
            long l1 = (long)super._ulx + (long)((plotpoint.x - super._xMin) * super._xscale);
            if(j < vector.size() - 1)
            {
                PlotPoint plotpoint2 = (PlotPoint)vector.elementAt(j + 1);
                int k = super._ulx + (int)((plotpoint2.x - super._xMin) * super._xscale);
                int j1 = super._lry - (int)((plotpoint2.y - super._yMin) * super._yscale);
                if(plotpoint2.connected)
                    _drawLine(g, i, k, j1, l1, l, true);
                plotpoint2.connected = false;
            }
            Format format = (Format)_formats.elementAt(i);
            if(format.impulsesUseDefault)
            {
                if(_impulses)
                    _drawImpulse(g, l1, l, true);
            } else
            if(format.impulses)
                _drawImpulse(g, l1, l, true);
            int i1 = _marks;
            if(!format.marksUseDefault)
                i1 = format.marks;
            if(i1 != 0)
                _drawPoint(g, i, l1, l, true, plotpoint.selected, plotpoint.highlighted);
            if(_bars)
                _drawBar(g, i, l1, l, true);
            if(plotpoint.errorBar)
                _drawErrorBar(g, i, l1, (long)super._lry - (long)((plotpoint.yLowEB - super._yMin) * super._yscale), (long)super._lry - (long)((plotpoint.yHighEB - super._yMin) * super._yscale), true);
            g.setColor(super._foreground);
            if(_pointsPersistence > 0 || _xPersistence > 0.0D)
                g.setPaintMode();
        }
        Vector vector1 = (Vector)_points.elementAt(i);
        if(vector1 != null)
        {
            PlotPoint plotpoint1 = (PlotPoint)vector1.elementAt(j);
            if(plotpoint1 != null)
            {
                if(plotpoint1.x == super._xBottom || plotpoint1.x == super._xTop || plotpoint1.y == super._yBottom || plotpoint1.y == super._yTop)
                    _xyInvalid = true;
                vector1.removeElementAt(j);
            }
        }
    }

    private void _fillPlot()
    {
        if(_xyInvalid)
        {
            super._xBottom = 1.7976931348623157E+308D;
            super._xTop = -1.7976931348623157E+308D;
            super._yBottom = 1.7976931348623157E+308D;
            super._yTop = -1.7976931348623157E+308D;
            for(int i = 0; i < _points.size(); i++)
            {
                Vector vector = (Vector)_points.elementAt(i);
                for(int j = 0; j < vector.size(); j++)
                {
                    PlotPoint plotpoint = (PlotPoint)vector.elementAt(j);
                    if(plotpoint.x < super._xBottom)
                        super._xBottom = plotpoint.x;
                    if(plotpoint.x > super._xTop)
                        super._xTop = plotpoint.x;
                    if(plotpoint.y < super._yBottom)
                        super._yBottom = plotpoint.y;
                    if(plotpoint.y > super._yTop)
                        super._yTop = plotpoint.y;
                }

            }

        }
        _xyInvalid = false;
        if(_bars)
        {
            if(super._yBottom > 0.0D)
                super._yBottom = 0.0D;
            if(super._yTop < 0.0D)
                super._yTop = 0.0D;
        }
        super.fillPlot();
    }

    private boolean _isConnected(int i)
    {
        if(i < 0)
            return _connected;
        _checkDatasetIndex(i);
        Format format = (Format)_formats.elementAt(i);
        if(format.connectedUseDefault)
            return _connected;
        else
            return format.connected;
    }

    public Vector _points;
    protected int _currentdataset;
    protected volatile int _marks;
    private int _pointsPersistence;
    private double _xPersistence;
    private boolean _bars;
    private double barWidth;
    private double _barOffset;
    private boolean _connected;
    private boolean _impulses;
    private int _maxDataset;
    private boolean _reuseDatasets;
    private boolean _firstInSet;
    private boolean _sawFirstDataSet;
    private int _radius;
    private int _diameter;
    private Vector _prevx;
    private Vector _prevy;
    private static final int _ERRORBAR_LEG_LENGTH = 5;
    private static final int _MAX_MARKS = 10;
    private boolean _xyInvalid;
    private String _filename;
    private boolean _showing;
    private Vector _formats;
    private final Color HIGHLIGHT_COLOR = new Color(0xff0000);





}
