// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PlotBoxProperties.java

package voplot.ptolemy.plot;

import com.jvt.applets.PlotButtons;
import com.jvt.applets.PlotVOApplet;
import java.awt.Color;
import java.io.*;
import java.util.ArrayList;
import java.util.Vector;

// Referenced classes of package ptolemy.plot:
//            Histogram, Plot, PlotInfo, PlotPoints, 
//            PlotFilterData, PlotBox

public class PlotBoxProperties
    implements Serializable
{

    public PlotBoxProperties()
    {
        YLabel = new String();
        NoFils = 0;
        Marks = new String("dots");
        Colors = true;
        Histogram = false;
        Connected = false;
        Width = 0;
        BinWidth = -1D;
        _plotInfo = new ArrayList();
        _plotPoints = new ArrayList();
        _plotFilterData = new ArrayList();
    }

    public int getPlotInfoSize()
    {
        return _plotInfo.size();
    }

    public void setPlotBoxProperties(PlotVOApplet plotvoapplet, PlotBox plotbox, PlotButtons plotbuttons)
    {
        pb = plotbox;
        pva = plotvoapplet;
        buttons = plotbuttons;
        Title = pb.getTitle();
        XLabel = pb.getXLabel();
        YLabel = pb.getYLabel();
        NoPlots = pva.getNumPlots();
        Grid = pb.getGrid();
        Colors = pb.getColor();
        Overlay = pva.toOverlay();
        Histogram = pva.isHistogram();
        Height = pva.getAppletHeight();
        Width = pva.getAppletWidth();
        XRange = pb.getXRange();
        YRange = pb.getYRange();
        XTicks = pb.getXTicks();
        YTicks = pb.getYTicks();
        Background = pva.getBackColor();
        Foreground = pva.getForeColor();
        if(pb instanceof Histogram)
        {
            Histogram histogram = (Histogram)pb;
            BinWidth = histogram.getBinWidth();
        }
        if(pb instanceof Plot)
        {
            Plot plot = (Plot)pb;
            Marks = plot.getMarksStyle();
            Impulses = plot.getImpulses();
            Connected = plot.getConnected();
        }
        dataGiven = false;
        NoCols = 0;
    }

    public void addPlotInfo(int i)
    {
        PlotInfo plotinfo = new PlotInfo();
        plotinfo.addSelectedXColName(buttons.getSelectedXColumn());
        plotinfo.addSelectedYColName(buttons.getSelectedYColumn());
        plotinfo.addSelectedFilterName(buttons.getSelectedFilter());
        plotinfo.addCatalogueIndex(pva.getCurrentPlotDataIndex());
        if(i == 1)
        {
            PlotInfo plotinfo1 = (PlotInfo)_plotInfo.get(0);
            plotinfo1.addLegend(pb.getLegend(0));
        }
        if(i >= 1)
            plotinfo.addLegend(pb.getLegend(i));
        plotinfo.addXLog(buttons.isLogX());
        plotinfo.addYLog(buttons.isLogY());
        plotinfo.addSelectedXColIndex(pva.getColumnIndex(buttons.getSelectedXColumn()));
        plotinfo.addSelectedYColIndex(pva.getColumnIndex(buttons.getSelectedYColumn()));
        plotinfo.setCooSysIndex(buttons.getSelectedCooSysIndex());
        for(int j = 0; j < noPlotsAsYet; j++)
        {
            PlotInfo plotinfo2 = (PlotInfo)_plotInfo.get(j);
            if(plotinfo2.getDataset() == i)
            {
                _plotInfo.set(j, plotinfo);
                return;
            }
        }

        noPlotsAsYet = i + 1;
        _plotInfo.add(plotinfo);
    }

    public PlotInfo getPlotInfo(int i)
    {
        return (PlotInfo)_plotInfo.get(i);
    }

    public void addPlotData(int i, Double adouble[])
    {
        for(int j = 0; j < NoCols; j++)
        {
            PlotPoints plotpoints = (PlotPoints)_plotPoints.get(j);
            if(plotpoints.getIndex() == i)
                return;
        }

        PlotPoints plotpoints1 = new PlotPoints();
        plotpoints1.addData(i, adouble);
        _plotPoints.add(plotpoints1);
        NoCols = NoCols + 1;
        dataGiven = true;
    }

    public PlotPoints getPlotData(int i)
    {
        for(int j = 0; j < NoCols; j++)
        {
            PlotPoints plotpoints = (PlotPoints)_plotPoints.get(j);
            if(plotpoints.getIndex() == i)
                return (PlotPoints)_plotPoints.get(j);
        }

        return null;
    }

    public void addFilterData(String s, boolean aflag[])
    {
        for(int i = 0; i < NoFils; i++)
        {
            PlotFilterData plotfilterdata = (PlotFilterData)_plotFilterData.get(i);
            if(plotfilterdata.getFilterName().equals(s))
                return;
        }

        PlotFilterData plotfilterdata1 = new PlotFilterData();
        plotfilterdata1.addFilterData(s, aflag);
        _plotFilterData.add(plotfilterdata1);
        NoFils = NoFils + 1;
    }

    public PlotFilterData getFilterData(String s)
    {
        for(int i = 0; i < NoFils; i++)
        {
            PlotFilterData plotfilterdata = (PlotFilterData)_plotFilterData.get(i);
            if(plotfilterdata.getFilterName().equals(s))
                return (PlotFilterData)_plotFilterData.get(i);
        }

        return null;
    }

    public void clearAll()
    {
        _plotInfo.clear();
        _plotPoints.clear();
        noPlotsAsYet = 0;
        NoCols = 0;
    }

    public void clearData()
    {
        _plotPoints.clear();
        NoCols = 0;
    }

    public String getTitle()
    {
        return Title;
    }

    public String getXLabel()
    {
        return XLabel;
    }

    public String getYLabel()
    {
        return YLabel;
    }

    public boolean isGrid()
    {
        return Grid;
    }

    public boolean getColor()
    {
        return Colors;
    }

    public boolean toOverlay()
    {
        return Overlay;
    }

    public boolean isHistogram()
    {
        return Histogram;
    }

    public int getHeight()
    {
        return Height;
    }

    public int getWidth()
    {
        return Width;
    }

    public double[] getXRange()
    {
        return XRange;
    }

    public double[] getYRange()
    {
        return YRange;
    }

    public double getBinWidth()
    {
        return BinWidth;
    }

    public String getXTicks()
    {
        String s = new String();
        if(XTicks != null)
        {
            for(int i = 0; i < XTicks[1].size(); i++)
                s = s + XTicks[1].get(i) + " " + XTicks[0].get(i) + ", ";

        }
        return s;
    }

    public String getYTicks()
    {
        String s = new String();
        if(YTicks != null)
        {
            for(int i = 0; i < YTicks[1].size(); i++)
                s = s + YTicks[1].get(i) + " " + YTicks[0].get(i) + ", ";

        }
        return s;
    }

    public Color getBackColor()
    {
        return Background;
    }

    public Color getForeColor()
    {
        return Foreground;
    }

    public String getMarks()
    {
        return Marks;
    }

    public boolean isConnected()
    {
        return Connected;
    }

    public boolean isImpulses()
    {
        return Impulses;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
        objectoutputstream.writeObject(Title);
        objectoutputstream.writeObject(XLabel);
        objectoutputstream.writeObject(YLabel);
        objectoutputstream.writeInt(NoPlots);
        objectoutputstream.writeInt(NoCols);
        objectoutputstream.writeInt(NoFils);
        objectoutputstream.writeBoolean(Grid);
        objectoutputstream.writeBoolean(Colors);
        objectoutputstream.writeBoolean(Overlay);
        objectoutputstream.writeBoolean(Histogram);
        objectoutputstream.writeInt(Height);
        objectoutputstream.writeInt(Width);
        objectoutputstream.writeObject(XRange);
        objectoutputstream.writeObject(YRange);
        objectoutputstream.writeObject(XTicks);
        objectoutputstream.writeObject(YTicks);
        objectoutputstream.writeObject(Background);
        objectoutputstream.writeObject(Foreground);
        objectoutputstream.writeBoolean(dataGiven);
        objectoutputstream.writeObject(_plotInfo);
        objectoutputstream.writeObject(_plotFilterData);
        if(!Histogram)
        {
            objectoutputstream.writeObject(Marks);
            objectoutputstream.writeBoolean(Impulses);
            objectoutputstream.writeBoolean(Connected);
        } else
        {
            objectoutputstream.writeDouble(BinWidth);
        }
        if(dataGiven)
            objectoutputstream.writeObject(_plotPoints);
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
        Title = (String)objectinputstream.readObject();
        XLabel = (String)objectinputstream.readObject();
        YLabel = (String)objectinputstream.readObject();
        NoPlots = objectinputstream.readInt();
        NoCols = objectinputstream.readInt();
        NoFils = objectinputstream.readInt();
        Grid = objectinputstream.readBoolean();
        Colors = objectinputstream.readBoolean();
        Overlay = objectinputstream.readBoolean();
        Histogram = objectinputstream.readBoolean();
        Height = objectinputstream.readInt();
        Width = objectinputstream.readInt();
        XRange = (double[])objectinputstream.readObject();
        YRange = (double[])objectinputstream.readObject();
        XTicks = (Vector[])objectinputstream.readObject();
        YTicks = (Vector[])objectinputstream.readObject();
        Background = (Color)objectinputstream.readObject();
        Foreground = (Color)objectinputstream.readObject();
        dataGiven = objectinputstream.readBoolean();
        _plotInfo = (ArrayList)objectinputstream.readObject();
        _plotFilterData = (ArrayList)objectinputstream.readObject();
        if(!Histogram)
        {
            Marks = (String)objectinputstream.readObject();
            Impulses = objectinputstream.readBoolean();
            Connected = objectinputstream.readBoolean();
        } else
        {
            BinWidth = objectinputstream.readDouble();
        }
        if(dataGiven)
            _plotPoints = (ArrayList)objectinputstream.readObject();
    }

    private PlotBox pb;
    private PlotVOApplet pva;
    private PlotButtons buttons;
    private String Title;
    private String XLabel;
    private String YLabel;
    private int NoPlots;
    private int NoCols;
    private int noPlotsAsYet;
    private int NoFils;
    private String Marks;
    private boolean Grid;
    private boolean Colors;
    private boolean Overlay;
    private boolean Histogram;
    private boolean Impulses;
    private boolean Connected;
    private int Height;
    private int Width;
    private double XRange[];
    private double YRange[] = {
        -1D, 1.0D
    };
    private Vector XTicks[];
    private Vector YTicks[];
    private Color Background;
    private Color Foreground;
    private double BinWidth;
    private boolean dataGiven;
    private ArrayList _plotInfo;
    private ArrayList _plotPoints;
    private ArrayList _plotFilterData;
}
