// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PlotTransformerDialog.java

package voplot.ptolemy.plot;

import com.jvt.applets.PlotVOApplet;
import com.jvt.ext.ColumnException;
import com.jvt.utils.JVTUtil;
import com.jvt.votable.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.PrintStream;
import java.util.EventObject;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import voplot.ptolemy.gui.*;

// Referenced classes of package ptolemy.plot:
//            PlotColumnTable, ColumnExprParser

public class PlotTransformerDialog extends JDialog
{

    public PlotTransformerDialog(Frame frame, PlotVOApplet plotvoapplet)
    {
        super(frame, "Create new virtual columns", true);
        _buttonPressed = "";
        _doneHandleClosing = false;
        _pva = null;
        _pd = null;
        init(plotvoapplet);
        addPanel(frame);
        pack();
    }

    private void addPanel(Frame frame)
    {
        JPanel jpanel = new JPanel();
        jpanel.setLayout(new BoxLayout(jpanel, 1));
        jpanel.add(_transPanel);
        _contents = _transPanel;
        _wideQuery.requestFocus();
        _optionPane = new JOptionPane(jpanel, 3, 1, null, _buttons, _buttons[0]);
        _optionPane.addPropertyChangeListener(new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent propertychangeevent)
            {
                String s = propertychangeevent.getPropertyName();
                if(isVisible() && propertychangeevent.getSource() == _optionPane && (s.equals("value") || s.equals("inputValue")))
                {
                    Object obj = _optionPane.getValue();
                    if(obj == JOptionPane.UNINITIALIZED_VALUE)
                        return;
                    _optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
                    if(obj instanceof String)
                        _buttonPressed = (String)obj;
                    if(PlotTransformerDialog._buttons[0].equals(_buttonPressed))
                        if(!applyChanges())
                        {
                            return;
                        } else
                        {
                            _transPanel.removeAll();
                            createColumnsTable();
                            _transPanel.invalidate();
                            _transPanel.validate();
                            return;
                        }
                    if(PlotTransformerDialog._buttons[2].equals(_buttonPressed))
                    {
                        JOptionPane.showMessageDialog(null, PlotTransformerDialog.availableFunctions, "Help for creating new virtual columns", 1);
                        return;
                    }
                    setVisible(false);
                    _handleClosing();
                }
            }

        });
        getContentPane().add(_optionPane);
        pack();
        setResizable(false);
        if(frame != null)
        {
            setLocationRelativeTo(frame);
        } else
        {
            Toolkit toolkit = Toolkit.getDefaultToolkit();
            setLocation((toolkit.getScreenSize().width - getSize().width) / 2, (toolkit.getScreenSize().height - getSize().height) / 2);
        }
        setDefaultCloseOperation(2);
        addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent windowevent)
            {
                _handleClosing();
            }

        });
        setVisible(true);
    }

    private void _handleClosing()
    {
        if((_contents instanceof CloseListener) && !_doneHandleClosing)
        {
            _doneHandleClosing = true;
            ((CloseListener)_contents).windowClosed(this, _buttonPressed);
        }
    }

    private void init(PlotVOApplet plotvoapplet)
    {
        _pva = plotvoapplet;
        _pd = plotvoapplet.getPlotData();
        _transPanel = new JPanel();
        createColumnsTable();
    }

    private void createColumnsTable()
    {
        _wideQuery = new Query();
        _wideQuery.requestFocus();
        _wideQuery.requestFocus();
        _wideQuery.setTextWidth(20);
        String s = "";
        _wideQuery.addLine("name", "Enter column name", s, "New column name");
        String s1 = "";
        _queryExpressionListener = _wideQuery.addLine("expr", "Enter expression", s1, "Expression for the new Column (e.g ($1+$2)*$3)", true);
        String s2 = "";
        _wideQuery.addLine("unit", "Enter unit", s2, "Unit (e.g deg)");
        _wideQuery.addQueryListener(new QueryListener() {

            public void changed(String s3)
            {
            }

        });
        _wideQuery.addQueryCaretListener(new QueryExpressionCaretListener() {

            public void changed(String s3, int i)
            {
                _queryExpressionListener.setCaretPosition(i);
            }

        });
        try
        {
            _table = new PlotColumnTable(_pd, _queryExpressionListener);
            _table.setPreferredScrollableViewportSize(new Dimension(200, 160));
            _scrollPane = new JScrollPane(_table);
            _scrollPane.setRequestFocusEnabled(false);
            _columnMetadata = new JPanel(new BorderLayout());
            JLabel jlabel = new JLabel("Click on a row to choose a Column Id.");
            JVTUtil.usePlainFont(jlabel);
            _columnMetadata.add(jlabel, "North");
            _columnMetadata.add(new JLabel(" "), "Center");
            _columnMetadata.add(_scrollPane, "South");
            TitledBorder titledborder = new TitledBorder("Column Metadata");
            _columnMetadata.setBorder(titledborder);
            _transPanel.setLayout(new BorderLayout());
            _transPanel.add(_columnMetadata, "North");
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
        JPanel jpanel = createOperatorPanel();
        _transPanel.add(jpanel, "Center");
        _transPanel.add(_wideQuery, "South");
        JPanel jpanel1 = new JPanel();
        _transPanel.add(jpanel1, "South");
        jpanel1.add(_wideQuery);
    }

    public static boolean addColumn(PlotVOApplet plotvoapplet, String s, String s1, String s2)
        throws ColumnException
    {
        PlotData plotdata = plotvoapplet.getPlotData();
        PlotColumn plotcolumn = new PlotColumn();
        int i = checkColNameValid(plotdata, s);
        if(i > 0)
            if(plotvoapplet.isExternalApplication())
            {
                throw new ColumnException(errorMessages[i]);
            } else
            {
                JOptionPane.showMessageDialog(null, errorMessages[i], "Error", 0);
                return false;
            }
        if(null == s1)
            s1 = "";
        plotcolumn.setUnit(s1);
        plotcolumn.setName(s);
        plotcolumn.setDatatype("double");
        try
        {
            if(s2 != null && s2.trim().length() <= 0)
                if(plotvoapplet.isExternalApplication())
                {
                    throw new ColumnException(errorMessages[3]);
                } else
                {
                    JOptionPane.showMessageDialog(null, errorMessages[3], "Error", 0);
                    return false;
                }
            s2 = s2.trim();
            plotcolumn.setExpression(s2);
            ColumnExprParser columnexprparser = new ColumnExprParser(plotdata);
            if(!columnexprparser.parseAndEvaluate(s2, plotcolumn))
            {
                if(columnexprparser.getErrorCode() == 4)
                {
                    String s3 = columnexprparser.getColumnNumber();
                    if(plotvoapplet.isExternalApplication())
                        throw new ColumnException("Invalid column number : $" + s3 + ". Please check the expression.");
                    JOptionPane.showMessageDialog(null, "Invalid column number : $" + s3 + ". Please check the expression.", "Error", 0);
                } else
                {
                    if(plotvoapplet.isExternalApplication())
                        throw new ColumnException(errorMessages[columnexprparser.getErrorCode()]);
                    JOptionPane.showMessageDialog(null, errorMessages[columnexprparser.getErrorCode()], "Error", 0);
                }
                return false;
            }
            plotcolumn.setUserCreated(true);
            plotdata.addPlotColumn(plotcolumn);
            plotvoapplet.setPlotData(plotdata, false);
            if(!plotvoapplet.isExternalApplication())
                JOptionPane.showMessageDialog(null, "Created column '" + plotcolumn.getName() + "' successfully.", "Success", 1);
        }
        catch(Exception exception)
        {
            if(plotvoapplet.isExternalApplication())
            {
                throw new ColumnException(errorMessages[5]);
            } else
            {
                JOptionPane.showMessageDialog(null, errorMessages[5], "Error", 0);
                return false;
            }
        }
        return true;
    }

    private boolean applyChanges()
    {
        JVTUtil.showWaitCursor(this);
        boolean flag = false;
        try
        {
            flag = addColumn(_pva, _wideQuery.getStringValue("name"), _wideQuery.getStringValue("unit"), _wideQuery.getStringValue("expr"));
        }
        catch(ColumnException columnexception)
        {
            System.out.println(columnexception);
        }
        JVTUtil.showDefaultCursor(this);
        return flag;
    }

    private void printColData(PlotColumn plotcolumn)
    {
        Double adouble[] = plotcolumn.getData();
        System.out.println(plotcolumn.getName() + " data length = " + adouble.length);
        for(int i = 0; i < adouble.length; i++)
            System.out.println(adouble[i].toString());

        System.out.flush();
    }

    public static int checkColNameValid(PlotData plotdata, String s)
    {
        if(null == plotdata)
            return 6;
        if(null == s || s.trim().length() <= 0)
            return 1;
        if(s.length() > 15)
            return 7;
        for(int i = 0; i < plotdata.getNumOfPlotColumns(); i++)
            if(s.equals(plotdata.getPlotColumn(i).getName()))
                return 2;

        return 0;
    }

    private JPanel createOperatorPanel()
    {
        JPanel jpanel = new JPanel();
        jpanel.setLayout(new GridLayout(3, 6));
        TitledBorder titledborder = new TitledBorder("Operator Calculator");
        jpanel.setBorder(titledborder);
        JButton ajbutton[] = new JButton[18];
        for(int i = 0; i < 18; i++)
        {
            ajbutton[i] = new JButton(operatorsOnDialog[i]);
            addOperatorListener(i, ajbutton[i]);
            jpanel.add(ajbutton[i]);
            JVTUtil.usePlainFont(ajbutton[i]);
            if(toolTipRequired[i])
                ajbutton[i].setToolTipText(toolTipText[i]);
        }

        return jpanel;
    }

    private void addOperatorListener(final int i, JButton jbutton)
    {
        jbutton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                _operatorButtons_actionPerformed(actionevent, i);
            }

        });
    }

    private void _operatorButtons_actionPerformed(ActionEvent actionevent, int i)
    {
        String s = operators[i];
        if(i < 4)
            _queryExpressionListener.changed(s, true);
        else
            _queryExpressionListener.changed(s, false);
    }

    public Component _contents;
    protected String _buttonPressed;
    private static final String _buttons[] = {
        "Add", "Close", "Help"
    };
    private boolean _doneHandleClosing;
    private JOptionPane _optionPane;
    private JTextArea _messageArea;
    private PlotVOApplet _pva;
    private PlotData _pd;
    private Query _wideQuery;
    private JTable _table;
    private JScrollPane _scrollPane;
    private JPanel _transPanel;
    private JPanel _columnMetadata;
    private QueryExpressionListener _queryExpressionListener;
    private static final int MAX_COL_DIGITS = 3;
    private static final short ERROR_NO_COL_NAME = 1;
    private static final short ERROR_COL_EXISTS = 2;
    private static final short ERROR_NO_DATA = 6;
    private static final short ERROR_LARGE_COL_NAME = 7;
    private static final String errorMessages[] = {
        "", "No Column name. Please enter a column name.", "Column name already exists. Please enter another name.", "No expression entered. Please enter an expression.", "Invalid column number. Please enter a correct expression.", "Exception while parsing expression. Please check that the expression is correct.", "No Data loaded in VOPlot", "Column name is too large. Please enter a name less than 15 characters."
    };
    private static final String operators[] = {
        "+", "-", "*", "/", "log", "ln", "sqrt", "pow", "dexp", "exp", 
        "cos", "acos", "sin", "asin", "tan", "atan", "toradians", "todegrees"
    };
    private static final String operatorsOnDialog[] = {
        "+", "-", "*", "/", "log", "ln", "sqrt", "pow", "dexp", "exp", 
        "cos", "acos", "sin", "asin", "tan", "atan", "torad", "todeg"
    };
    private static final boolean toolTipRequired[] = {
        false, false, false, false, true, true, false, false, true, true, 
        false, false, false, false, false, false, true, true
    };
    private static final String toolTipText[] = {
        "", "", "", "", "Log to the base 10", "Natural Log", "", "", "10 raised to the value", "e raised to the value", 
        "", "", "", "", "", "", "toradians", "todegrees"
    };
    private static final int OPERATOR_COUNT = 4;
    private static final int OPERATOR_FUNCTION_COUNT = 18;
    private static final String availableFunctions[] = {
        " ", "Operators available for use in the Transformation Dialog Box    ", " ", "       ' + ',  ' - ',  ' * ',  ' / '  ", " ", "Functions available for use in the Transformation Dialog Box    ", " ", "       log(a)                          ln(a)", "       sqrt(a)                        pow(a,b)", "       dexp(a)                       exp(a)", 
        "       cos(a)                         acos(a)", "       sin(a)                          asin(a)", "       tan(a)                          atan(a)", "       toradians(a)              todegrees(a)", " ", "For example, $1 + sin((3.14 * $2) / $2)", " "
    };










}
